codeforces 37E Trial for Chief

48 篇文章 0 订阅
38 篇文章 0 订阅

Having unraveled the Berland Dictionary, the scientists managed to read the notes of the chroniclers of that time. For example, they learned how the chief of the ancient Berland tribe was chosen.

As soon as enough pretenders was picked, the following test took place among them: the chief of the tribe took a slab divided by horizontal and vertical stripes into identical squares (the slab consisted of N lines and M columns) and painted every square black or white. Then every pretender was given a slab of the same size but painted entirely white. Within a day a pretender could paint any side-linked set of the squares of the slab some color. The set is called linked if for any two squares belonging to the set there is a path belonging the set on which any two neighboring squares share a side. The aim of each pretender is to paint his slab in the exactly the same way as the chief’s slab is painted. The one who paints a slab like that first becomes the new chief.

Scientists found the slab painted by the ancient Berland tribe chief. Help them to determine the minimal amount of days needed to find a new chief if he had to paint his slab in the given way.

Input

The first line contains two integers N and M (1 ≤ N, M ≤ 50) — the number of lines and columns on the slab. The next N lines containM symbols each — the final coloration of the slab. W stands for the square that should be painted white and B — for the square that should be painted black.

Output

In the single line output the minimal number of repaintings of side-linked areas needed to get the required coloration of the slab.

Examples
input
3 3
WBW
BWB
WBW
output
2
input
2 3
BBB
BWB
output
1

~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

SPFA+贪心+神奇的思路~

对于直接相邻的两个格子连边,如果颜色相同,则权值为0,反之为1,然后在图上跑最短路,显然对于每个单位距离,我们都要重新染色一次,所以答案即为从某一个点出发最远距离的最小值+1,时间复杂度O(n^2*m^2)。

又因为简化代码WA到飞起……好气呀……


#include<cstdio>
#include<iostream>
#include<queue>
using namespace std;

int n,m,fi[25001],ne[200001],w[200001],v[200001],cnt,dis[25001],maxx,ans,numx[5]={0,0,0,1,-1},numy[5]={0,1,-1,0,0};
bool b[25001];
char s[51][51];

void add(int u,int vv,int val)
{
	w[++cnt]=vv;v[cnt]=val;ne[cnt]=fi[u];fi[u]=cnt;
}

bool findd(int u)
{
	deque<int> q;
	for(int i=1;i<=n*m;i++) b[i]=0;
	q.push_back(u);b[u]=1;dis[u]=0;
	while(!q.empty())
	{
		int k=q.front();q.pop_front();
		for(int i=fi[k];i;i=ne[i])
		  if(!b[w[i]])
		  {
		  	dis[w[i]]=dis[k]+v[i];b[w[i]]=1;
		  	if(v[i]) q.push_back(w[i]);
		  	else q.push_front(w[i]);
		  }
	}
}

int main()
{
	scanf("%d%d",&n,&m);
	for(int i=1;i<=n;i++) scanf("%s",s[i]+1);
	for(int i=1;i<=n;i++)
	  for(int j=1;j<=m;j++)
	    for(int k=1;k<=4;k++)
	      if(i+numx[k]>=1 && i+numx[k]<=n && j+numy[k]>=1 && j+numy[k]<=m)
	      {
	      	int ii=i+numx[k],jj=j+numy[k];
	      	add((ii-1)*m+jj,(i-1)*m+j,s[i][j]!=s[ii][jj]);
	      }
	for(int i=1;i<=n*m;i++)
	{
		maxx=-1;findd(i);
		for(int j=1;j<=n;j++)
		  for(int k=1;k<=m;k++)
		    if(s[j][k]=='B') maxx=max(maxx,dis[j*m-m+k]);
		if(i==1) ans=maxx;
		else ans=min(maxx,ans);
	}
	printf("%d\n",ans+1);
	return 0;
}


  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值